function updateGraphTooltip(event, pos, item, previousIndex, tooltip, plot) {
  if (item) {
    if (previousIndex != item.dataIndex) {
      previousIndex = item.dataIndex;
      var plot_offset = plot.getPlotOffset();
      var offset = plot.offset();
      tooltip.find(".x").html(item.series.xaxis.tickFormatter(
        item.datapoint[0], item.series.xaxis));
      tooltip.find(".y").html(item.series.yaxis.options.axisLabel + " : " +
        item.datapoint[1]);
      tooltip.css("left", item.pageX - offset.left + plot_offset.left + 5
        + "px");
      tooltip.show();
      // query offsetHeight *after* making the tooltip visible
      tooltip.css("top", item.pageY - offset.top + plot_offset.top - 5
        - tooltip.prop("offsetHeight") + "px");
    }
  } else {
    if (previousIndex != null) {
      tooltip.hide();
      previousIndex = null;
    }
  }
  return previousIndex;
}
function renderGraph(container) {
  var container = $(container);
  var previousIndex = null;
  var tooltip = container.next(".tooltip");
  var plot = $.plot(
    container,
    $.parseJSON(container.attr("data-points")),
    $.parseJSON(container.attr("data-options"))
  );
  tooltip.detach();
  container.append(tooltip);
  container.bind("plothover", function (event, pos, item) {
    previousIndex = updateGraphTooltip(event, pos, item, previousIndex,
      tooltip, plot);
  });
}
function toggleGraph(node) {
  var container = $(node).parent().find(".container");
  // Note: toggling *after* rendering cause layout problems with flot.
  container.toggle();
  if (container.attr("data-rendered-marker") == null) {
    container.attr("data-rendered-marker", "rendered");
    container.find(".graph").each(function (i){renderGraph(this)});
  }
}
function hideGraph(node) {
  $(node).parent().hide();
}
$(function() {
  $(".graph:visible").each(function (i){renderGraph(this)});
  $(".hidden_graph .container").draggable();
});
